#include <bits/stdc++.h>
#define int long long
using namespace std;

string to_string(string s) { return s; }
template <typename T> string to_string(T v) {
    string res = "[";
    for (const auto &x : v) {
        res += to_string(x) + ", ";
    }
    res += "]";
    return res;
}

void dbg_out() { cout << endl; }
template<typename Head, typename... Tail> void dbg_out(Head H, Tail... T) {
    cout << ' ' << to_string(H);
    dbg_out(T...);
}

#ifdef DEBUG
#define dbg(...) cout << "(" << #__VA_ARGS__ << "):", dbg_out(__VA_ARGS__)
#else
#define dbg(...)
#endif

using ll = long long;
using vi = vector<int>;
#define rep(i, a, b) for (int i = (a); i < (b); ++i)
#define all(v) (v).begin(), (v).end()
#define sz(v) ((int)(v).size())

const int NB_NODES = 24;

mt19937 rng(69420);

int randint(int lb, int ub) {
    return uniform_int_distribution<int>(lb, ub - 1)(rng);
}

string Color[NB_NODES];

signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout << NB_NODES << endl;
    for (int i = 0; i < NB_NODES; i ++)
    {
        Color[i].resize(NB_NODES);
        for (int j = 0; j < NB_NODES; j ++)
        {
            Color[i][j] = i == j ? '.' : '?';
        }
    }
    for (int i = 0; i < NB_NODES / 2; i ++)
    {
        int a = randint(0, NB_NODES);
        int b = randint(0, NB_NODES);
        while (a == b)
            b = randint(0, NB_NODES);
        int c = randint(0, 2);
        Color[a][b] = Color[b][a] = c ? 'S' : 'F';
    }
    for (int i = 0; i < NB_NODES; i ++)
        cout << Color[i] << endl;
    return 0;
}